<?
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//  TITLE:                IRCSERVICES XML to MySQL
//  REVISION:             0.5
//  AUTHOR:               Dereck Martin <dmartin@tekconxus.com>
//  CREATED:              August 01, 2007
//  LAST UPDATE:          August 05, 2007
//
//  PURPOSE:              To convert download & convert the exported XML
//                        to mysql for use in web applications.
//
//  USE:                  php -f ircservices-xml2mysql.php
//
//  TODO:                 Add more DB Entries for other statistics. Not all 
//                        values are exported from XML.  If there is pressure
//                        to support all items, I will in a future release.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


  // set db information
  $db_host="localhost";
  $db_username="<username>";
  $db_password="<password>";		
  $db_database="ircservices";			// DO NOT CHANGE
  
  // make db connection
  $db_connect = mysql_connect($db_host,$db_username,$db_password);
  mysql_select_db($db_database, $db_connect);

  // get xml file - set url to your ircservices http address
  $xml_fname = "ircservices.xml";
	$xml_url = "http://10.10.0.4:8080/dbaccess/xml-export/";
		
	// get xml with wget to current directory
	exec("wget -O ".$xml_fname." ".$xml_url);
	$xml = simplexml_load_file($xml_fname);
	
	// set some counter for later
	$counter_update = 0;
	$counter_new = 0;
	$counter_delete = 0;
	$date = date("Ymd");
	
/*****************************************************************************
  Update / Insert / Delete NickInfo Section
*****************************************************************************/

	echo "Processing NickInfo Section:\n";
	foreach ($xml->nickinfo as $nickinfo) {
    $result = mysql_query("SELECT * FROM nickinfo where nick='$nickinfo->nick';") 
                or die("Error");
    
    $nick = $nickinfo->nick;
    $status = $nickinfo->status;
    $time_registered = $nickinfo->time_registered;
    $last_seen = $nickinfo->last_seen;
    $nickgroup = $nickinfo->nickgroup;
    
    if(mysql_num_rows($result) == 0) {
      echo "+";
      mysql_query("INSERT INTO nickinfo (nick,status,time_registered,last_seen,nickgroup,last_db_update) 
        VALUES('$nick','$status','$time_registered','$last_seen','$nickgroup','$date');");
      $counter_new++;
    }
    else {
      echo "^";
      mysql_query("UPDATE nickinfo 
        set nick='$nick', 
        status='$status', 
        time_registered='$time_registered',
        last_seen='$last_seen', 
        nickgroup='$nickgroup', 
        last_db_update='$date' 
        WHERE nick='$nick';");
      
      $counter_update++;
    }
    mysql_free_result($result);
	}
	$result = mysql_query("SELECT * FROM nickinfo where last_db_update <> '$date';");
	
	$i = 0;
	while ($i < mysql_num_rows($result)) {
	  echo "-";
	  $i++;
	}
	
	echo "\n";
	$counter_delete += mysql_num_rows($result);
	$purge_result = mysql_query("DELETE FROM nickinfo where last_db_update <> '$date';");
	mysql_free_result($result);
	
/******************************************************************************
  Update / Insert / Delete ChannelInfo Section
******************************************************************************/
	
  echo "Processing ChannelInfo Section:\n";
  foreach ($xml->channelinfo as $channelinfo) {
    $result = mysql_query("SELECT * FROM channelinfo where name='$channelinfo->name';") 
                  or die("Error");
                    
    $name = $channelinfo->name;
    $founder_id = $channelinfo->founder;
    $founder_pass = md5($channelinfo->foundpass);
    $desc = $channelinfo->desc;
    $url = $channelinfo->url;
    $email = $channelinfo->email;
    $time_registered = $channelinfo->time_registered;
    $last_used = $channelinfo->last_used;
    $last_topic = $channelinfo->last_topic;
    $last_topic_setter = $channelinfo->last_topic_setter;
    $flags = $channelinfo->flags;
    $mlock_on = $channelinfo->mlock_on;
    $mlock_off = $channelinfo->mlock_off;
    
    if ($url == '') {
        $url = "none";
    }
   
    if(mysql_num_rows($result) == 0) {
      echo "+";
      mysql_query("INSERT INTO channelinfo 
        (name,founder,founderpass,description,url,email,time_registered,last_used,last_topic,last_topic_setter,flags,mlock_on,mlock_off,last_db_update) 
        VALUES('$name','$founder_id','$founder_pass','$desc','$url','$email','$time_registered','$last_used','$last_topic','$last_topic_setter','$flags','$mlock_on','$mlock_off','$date');")
          or die(mysql_error());
      $counter_new++;
    }
    else {
      echo "^";
      mysql_query("UPDATE channelinfo
                          set name='$name',
                          founder='$founder_id',
                          founderpass='$founder_pass',
                          description='$desc',
                          url='$url',
                          time_registered='$time_registered',
                          last_used='$last_used',
                          last_topic='$last_topic',
                          last_topic_setter='$last_topic_setter',
                          flags='$flags',
                          mlock_on='$mlock_on',
                          mlock_off='$mlock_off',
                          last_db_update='$date'
                          WHERE name='$name';") or die(mysql_error());
      
      $counter_update++;
    }
    mysql_free_result($result);
  }
  
  $result = mysql_query("SELECT * FROM channelinfo where last_db_update <> '$date';");
	
	$i = 0;
	while ($i < mysql_num_rows($result)) {
	  echo "-";
	  $i++;
	}
	$counter_delete += mysql_num_rows($result);
	mysql_query("DELETE FROM channelinfo where last_db_update <> '$date';");
	mysql_free_result($result);
	
	echo "\n";
	
/******************************************************************************
  Insert / Update / Delete NickGroupInfo Section
******************************************************************************/
	
  echo "Processing NickGroupInfo Section:\n";
  
  foreach ($xml->nickgroupinfo as $nickgroupinfo) {
    $result = mysql_query("SELECT * FROM nickgroupinfo where id='$nickgroupinfo->id';") 
                  or die("Error");
                  
    $id = $nickgroupinfo->id;
    $mainnick = intval($nickgroupinfo->mainnick);
    $main = $nickgroupinfo->nicks->{"array-element"}[$mainnick];
    $pass = md5($nickgroupinfo->pass);
    $email = $nickgroupinfo->email;
    $flags = $nickgroupinfo->flags;

    // Add multiple "Linked" nicks to a single line seperated by commas
    $nicks = '';
    foreach ($nickgroupinfo->nicks->{"array-element"} as $linked_nicks) {
      $nicks = $nicks.$linked_nicks.",";
    }
    
    $nicks = substr($nicks, 0, -1);
    
    if(mysql_num_rows($result) == 0) {
      echo "+";
      mysql_query("INSERT INTO nickgroupinfo (id,nicks,mainnick,pass,url,email,flags,last_db_update) 
        VALUES('$id','$nicks','$main','$pass','$url','$email','$flags','$date');")
          or die(mysql_error());
      $counter_new++;
    }
    else {
      echo "^";
      mysql_query("UPDATE nickgroupinfo 
                          set id='$id', 
                          nicks='$nicks', 
                          mainnick='$main', 
                          pass='$pass', 
                          url='$url', 
                          email='$email', 
                          flags='$flags', 
                          last_db_update='$date' 
                          WHERE id='$id';") or die(mysql_error());
            
      $counter_update++;
    }
    mysql_free_result($result);  
  }
  
  $result = mysql_query("SELECT * FROM nickgroupinfo where last_db_update <> '$date';");
	
	$i = 0;
	while ($i < mysql_num_rows($result)) {
	  echo "-";
	  $i++;
	}
	$counter_delete += mysql_num_rows($result);
	mysql_query("DELETE FROM nickgroupinfo where last_db_update <> '$date';");
	mysql_free_result($result);
	
	echo "\n";
  echo "Updated: ".$counter_update."\n";
	echo "Added: ".$counter_new."\n";
	echo "Deleted: ".$counter_delete."\n";
	exec("rm ".$xml_fname);
?>